// WinAVR 20030913

#include <avr/io.h>

#define u08 unsigned char
#define nop() asm volatile( "nop" );


void init(void)
{
}

int main(void)
{
	u08 Tasten1, Tasten2, Tasten_alt, Tasten_flanke, Lampen;

	DDRD  = 0x0;		// input
	PORTD = 0xFF;		// pull-ups
	DDRB  = 0xFF;		// outputs
	PORTB = 0xFF;

	while(1)
	{
		Tasten1 = PIND;
		nop();
		nop();
		nop();
		nop();
		nop();
		Tasten2 = PIND;
		if(Tasten1 == Tasten2)
		{
			Tasten2 = Tasten1 ^ Tasten_alt;					//Unterschied zu alten Tastern feststellen
			Tasten_flanke = Tasten2 & Tasten_alt;		//steigende Flanke bilden
			Tasten_alt = Tasten1;										//aktuellen Stand fr nchsten durchlauf speichern
		}

		Lampen=Lampen^Tasten_flanke;
		PORTB = ~Lampen;
	}

	return(0);
}
